//---------------------------------------------------------------------------
#pragma hdrstop
#include "Ukdisp.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

#include <math.h>
#include <limits.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX(x,y) ((x)<(y) ? (y) : (x))
//---------------------------------------------------------------------------
void le_arq_matriz(char nomearq[],  float **matrizDistancia);
void obter_parametros_prob(char nomearq[], int *n, int *cap, int *x_dep, int *y_dep);
void imprime_fo(char nomearq[], float tempo, int fo, int iteracao);
void le_arq_vetor(char nomearq[], int *vetor);
void le_arq_vetor_denso(char nomearq[], int *vetor);
void limpa_arquivo(char nomearq[]);
void inicializa_matriz(float **matriz, int nLin, int nCol);
int  le_num_arq(char nomeArq[]);
int *cria_vetor(int tam);
float *cria_vetor_float(int tam);
void libera_vetor(int *vetor);
int **cria_matriz(int nlinhas, int ncolunas);
float **cria_matriz_float(int nlinhas, int ncolunas);
void libera_matriz(int **matriz, int nlinhas);
void libera_matriz_float(float **matriz, int nlinhas);
void imprime_vetor(int *s, int n);
void imprime_rota(int *s, int n);
void imprime_rota(int *s, int n);
float calcula_fo (int n,  int *s, float **matrizDistancia);
float randomico(float min, float max);
void atualiza_vetor(int *s_star, int *s, int n);
void inicializa_vetor(int *vetor, int tam);
void inicializa_vetor(int *vetor, int tam);
void embaralha_vetor(int *vetor, int n);
void constroi_solucao_aleatoria(int *s, int n  );
float SA(int n,
         int *s,
         float **matrizDistancia,
         float alpha,
         float temp_inicial,
         float temp_final,
         int SAmax);
float temperatura_inicial(int n,
                          int *s,
                          float **matrizDistancia,
                          float beta,
                          float gamma,
                          int SAmax);





int main(int argc, char* argv[])
{
  int n;               // numero de cidades
  int k;               //Numero de Cidades Requerido; --> K
  int *s;              // vetor solucao corrente
  int  le_num_arq(char nomeArq[]);
  float **matrizDistancia;// distncia entre os clientes na soluo corrente
  int *s_star;     // vetor melhor soluo
  int dist;
  float fo_star;     // melhor funo objetivo
  float fo,            // funcao objetivo corrente
        temp_inicial;  // temperatura inicial Simulated Annealing
  clock_t inicio_CPU,
        fim_CPU;
  void inicializa_matriz(float **matriz, int nLin, int nCol);
  void le_arq_matriz(char nomearq[],  float **matrizDistancia);


 int menu_principal(void);
 int escolha = 0;
  do {
      escolha = menu_principal();
      switch (escolha) {
      case 1: /* Geracao aleatria de uma solucao inicial */
                  srand((unsigned) time(NULL)); // pega a hora do relgio como semente
                  n = le_num_arq("numcidades.txt");
                  n = n+1;
                  k = 3;
                  s = cria_vetor(n); // vetor solucao
                  inicializa_vetor( s, n);
                  matrizDistancia = cria_matriz_float( n, n);
                  inicializa_matriz (matrizDistancia , n, n);
                  le_arq_matriz("MatrizDistanciasteste.txt", matrizDistancia);
                  constroi_solucao_aleatoria(s, n);
                  //printf("\matriz = %f \n",matrizDistancia[2][2]);
                  //embaralha_vetor(s,n);
                  fo = calcula_fo(n, s, matrizDistancia);
                  printf("\nSolucao construida de forma aleatoria:\n");
                  imprime_rota(s, n);
                  printf("Menor Distncia = %f\n",fo);
	          break;
       case 2: /* Simulated Annealing */
           temp_inicial = temperatura_inicial(n,s,matrizDistancia,1.1,0.98,500);
           inicio_CPU = clock();
           fo = SA(n,s,matrizDistancia,0.95,temp_inicial,0.01,500);
           fim_CPU = clock();
           printf("\nSolucao construida usando o Metodo Simulated Annealing:\n");
           imprime_rota(s, n);
          printf("\nMenor distncia encontrada = %f \n",fo);
          printf("Tempo de CPU = %f segundos\n",(fim_CPU - inicio_CPU)/CLK_TCK);
          break;
   default:
          break;
    }
  } while (escolha != 0);



  libera_vetor(s);
  //libera_vetor(demanda);
  libera_matriz_float(matrizDistancia, n);
  return 0;

}

//---------------------------------------------------------------------------

float SA(int n,
         int *s,
         float **matrizDistancia,
         float alpha,
         float temp_inicial,
         float temp_final,
         int SAmax)
{
  int i, j, aux, iterT;
  float temperatura, delta, fo, fo_star;
  int *s_star;

  s_star = cria_vetor(n);
  atualiza_vetor(s_star,s,n);
  temperatura = temp_inicial;
  fo_star = fo = calcula_fo(n, s, matrizDistancia);
  while (temperatura > temp_final){
    iterT = 0;
    while (iterT < SAmax){
      iterT++;
      // Gere um vizinho qualquer
      i = random(n);
      do{
        j = random(n);
      } while (j == i);
      float delta1 = calcula_fo(n, s, matrizDistancia);
      // Faz o movimento
      aux = s[j];
      s[j] = s[i];
      s[i] = aux;
      float delta2 = calcula_fo(n, s, matrizDistancia);
      delta = - delta1 + delta2;
      if (delta > 0){
         fo = fo + delta;
         if (fo > fo_star){
           fo_star = fo;
           atualiza_vetor(s_star,s,n);
           printf("Fo_star = %8.2f \t Temperatura = %8.2f \n", fo_star, temperatura);
         }
      }
      else{
        float x = randomico(0,1);
        if (x < exp(delta/temperatura)){
           fo = fo + delta;
        }
        else{
          // Desfaz o movimento
          aux = s[j];
          s[j] = s[i];
          s[i] = aux;
        }
      }

    }
    temperatura = alpha * temperatura;
  }
  atualiza_vetor(s,s_star,n);
  libera_vetor(s_star);
  return fo_star;
}



float temperatura_inicial(int n,
                          int *s,
                          float **matrizDistancia,
                          float beta,
                          float gamma,
                          int SAmax)
{
  int i, j, aux, iterT, aceitos;
  float temperatura, delta, fo;
  bool continua;

  temperatura = 10;
  continua = true;
  while (continua){
    aceitos = 0;
    iterT = 0;
    while (iterT < SAmax){
      iterT++;
      // Gere um vizinho qualquer
      i = random(n);
      do{
        j = random(n);
      } while (j == i);
      float delta1 = calcula_fo(n, s, matrizDistancia);
      // Faz o movimento
      aux = s[j];
      s[j] = s[i];
      s[i] = aux;
      float delta2 = calcula_fo(n, s, matrizDistancia);
      delta = - delta1 + delta2;
      if (delta < 0){
         aceitos++;
      }
      else{
        float x = randomico(0,1);
        if (x < exp(-delta/temperatura)){
           aceitos++;
        }
      }
      // Desfaz o movimento
      aux = s[j];
      s[j] = s[i];
      s[i] = aux;
    }
    if (aceitos < gamma * SAmax){
      temperatura = beta * temperatura;
    }
    else
      continua = false;
  }
  return temperatura;
}
//---------------------------------------------------------------------------

void le_arq_matriz(char nomearq[],  float **matrizDistancia)
{
 int i,         /* cliente A */
    j,           /* cliente B */
     distCidades; /* distncias entre os cidades*/
  FILE *arquivo;

  arquivo = fopen(nomearq,"r");
  if (!arquivo) {
     printf("O Arquivo %s nao pode ser aberto.\n",nomearq);
     exit(1);
  }
  while (!feof(arquivo)) {
    fscanf(arquivo, "%d %d %d", &i, &j, &distCidades);
    matrizDistancia[i][j]= distCidades;
  }
  fclose(arquivo);
}



void obter_parametros_prob(char nomearq[], int *n, int *cap, int *x_dep, int *y_dep)
{
  float best_sol=0;

  FILE *arquivo;

  arquivo = fopen(nomearq,"r");
  if (!arquivo) {
     printf("O Arquivo %s nao pode ser aberto.\n", nomearq);
     getchar();
     exit(1);
  }
  fscanf(arquivo, "%d %f", n, &best_sol);
  fscanf(arquivo, "%d", cap);
  fscanf(arquivo, "%d %d", x_dep, y_dep);

  fclose(arquivo);
}



void imprime_fo(char nomearq[], float tempo, int fo, int iteracao)
{
    FILE *arquivo;
    arquivo = fopen(nomearq,"a+");

    if (!arquivo){
        printf("O arquivo %s nao pode ser aberto",nomearq);
        getchar();
        exit(1);
    }
    fprintf(arquivo,"%4.2f\t  %4d\t  %5d\n",tempo, iteracao, fo);
    fclose(arquivo);
}


/* le um arquivo no formato i, valor */
void le_arq_vetor(char nomearq[], int *vetor)
{
  int j,
    valor;
  FILE *arquivo;

  arquivo = fopen(nomearq,"r");
  if (!arquivo) {
     printf("O Arquivo %s nao pode ser aberto.\n", nomearq);
     getchar();
     exit(1);
  }
  while (!feof(arquivo)){
    fscanf(arquivo, "%d, %d", &j, &valor);
    vetor[j] = valor;
  }
  fclose(arquivo);
}


/* Nesta leitura, vetor[j] = valor para todo j=0...n */
void le_arq_vetor_denso(char nomearq[], int *vetor)
{
  int j,
    valor;
  FILE *arquivo;

  arquivo = fopen(nomearq,"r");
  if (!arquivo) {
     printf("O Arquivo %s nao pode ser aberto.\n", nomearq);
     getchar();
     exit(1);
  }
  j = 0;
  while (!feof(arquivo)){
    fscanf(arquivo, "%d", &valor);
    vetor[j] = valor;
    j++;
  }
  fclose(arquivo);
}


void limpa_arquivo(char nomearq[])
{
  FILE *arquivo;
  arquivo = fopen(nomearq,"w");
  if (!arquivo){
     printf("O arquivo %s nao pode ser aberto",nomearq);
     getchar();
     exit(1);
  }
  fclose(arquivo);
}


//---------------------------------------------------------------------------

//inicializa matriz
void inicializa_matriz(float **matriz, int nLin, int nCol)
{
  for(int i=0; i<nLin; i++)
    for(int j=0; j<nCol;j++)
      matriz[i][j]=0;
}



//l um nmero de um arquivo
int  le_num_arq(char nomeArq[])
{
  int resultado;
  FILE *arquivo;

  arquivo = fopen(nomeArq,"r");
if(!arquivo)
  {
	 printf("O arquivo %s nao pode ser aberto. \n", nomeArq);
	 getchar();
	 return -1;
  }

  fscanf(arquivo, "%d", &resultado);
  fclose(arquivo);
  return resultado;
}



/* cria memoria para um vetor de tam posicoes */
int *cria_vetor(int tam)
{
  int *vetor;

  vetor = (int *) malloc(tam*sizeof(int));
  if (!vetor){
  	printf("Falta memoria para alocar o vetor de ponteiros");
    exit(1);
  }
  return vetor;
}


/* cria memoria para um vetor de tam posicoes */
float *cria_vetor_float(int tam)
{
  float *vetor;

  vetor = (float *) malloc(tam*sizeof(float));
  if (!vetor){
  	printf("Falta memoria para alocar o vetor de ponteiros");
    exit(1);
  }
  return vetor;
}


/* Cria matriz de ponteiros para inteiros com nlinhas e ncolunas */
int **cria_matriz(int nlinhas, int ncolunas)
{
  register int i;
  int **matriz;

  matriz = (int **) malloc(nlinhas*sizeof(int *));
  if (!matriz) {
        printf("Falta memoria para alocar a matriz de ponteiros\n");
        exit(1);
  }
  for (i=0; i < nlinhas; i++) {
    matriz[i] = (int *) malloc(ncolunas*sizeof(int));
    if (!matriz[i]){
      printf("Falta memoria para alocar a matriz de ponteiros.\n");
      exit(1);
    }
  }
  return matriz;
}


/* Cria matriz de ponteiros para inteiros com nlinhas e ncolunas */
float **cria_matriz_float(int nlinhas, int ncolunas)
{
  register int i;
  float **matriz;

  matriz = (float **) malloc(nlinhas*sizeof(float *));
  if (!matriz) {
        printf("Falta memoria para alocar a matriz de ponteiros\n");
        exit(1);
  }
  for (i=0; i < nlinhas; i++) {
    matriz[i] = (float *) malloc(ncolunas*sizeof(float));
    if (!matriz[i]){
      printf("Falta memoria para alocar a matriz de ponteiros.\n");
      exit(1);
    }
  }
  return matriz;
}



/* libera memoria de um vetor */
void libera_vetor(int *vetor)
{
  free(vetor);
}


void libera_matriz(int **matriz, int nlinhas)
{
  register int i;

  for (i=nlinhas-1; i >= 0; i--)
    free((int *) matriz[i]);
  free((int *) matriz);
}



void libera_matriz_float(float **matriz, int nlinhas)
{
  register int i;

  for (i=nlinhas-1; i >= 0; i--)
    free((float *) matriz[i]);
  free((float *) matriz);
}




/* imprime a solucao */
void imprime_vetor(int *s, int n)
{
    for (int j=0; j < n; j++) printf("s[%2d]=%d \n",j,s[j]);
}


/* imprime a solucao */
void imprime_rota(int *s, int n)
{
    for (int j=0; j < n; j++) printf("%d ",s[j]);
    }


/* calcula a funcao objetivo */
float calcula_fo (int n,  int *s, float **matrizDistancia) {
    int mdist = 100;
    int k = 3;
    int *a = cria_vetor(k);
    //Coloca em a as Cidades p/ calcular a dist.
    int t = 0;
    for (int i = 0; i < n; i++) {
      if (s[i] == 1) {
        a[t] = i;
        t++;
      }
    }
    int g = 1;
    for (int h = 0; h < k; h++)
    {
         int i = a[h];
         for (int m = g; m < k; m++ ) {
            int j = a [m];
            if ( (matrizDistancia[i][j]) < mdist)
               mdist = matrizDistancia[i][j];
             }
         g++;
        }
        return mdist  ;
          }


/* Gera numero aleatorio entre min e max */
float randomico(float min, float max)
{
  if (min == max) return min;
  return ((float) (rand()%10000/10000.0)*(max-min) + min);
}


/* atualiza a melhor solucao */
void atualiza_vetor(int *s_star, int *s, int n)
{
   for (int j=0; j < n; j++) s_star[j] = s[j];
}


void inicializa_vetor(int *vetor, int tam)
{
    for (int j=0; j<tam; j++) vetor[j] = 0;
}


void embaralha_vetor(int *vetor, int n)
{
  int aux, j1, j2;

  for (int i=0; i < n; i++)
  {
    j1 = random(n);
    j2 = random(n);
    while (j1 == j2) j2 = random(n);
    aux = vetor[j1];
    vetor[j1] = vetor[j2];
    vetor[j2] = aux;
  }
}


//void constroi_solucao(int n, int *s, float **distancia)
//{
  //for (int j=0; j < n; j++) s[j] = j;
//}
/* void constroi_solucao_aleatoria(int *s, int n  ) {
    int b = 0;
    int k = 4;
    bool ok;
    int j;
    for (int i = 0; i < k ; i++) {
      ok = false;
      while (!ok) {
        b = int (random(2) * n);
        if (s[b] == 0) {
          ok = true;
        }
      }
      s[b] = 1;
    }
     }
             */

void constroi_solucao_aleatoria(int *s, int n  )
{
 int b=0;
 //int c=0;
 int k=4;
 int *s1;
     s1 = cria_vetor(n);
     for (int j = 0; j < n; j++) {
     s1[j]= random(2);
     if (s1[j]==1)
        b = b++;
     //else c = c++;
     if ( b < k) //&& (c < k))
     s[j]= s1 [j];

 }
     }

//---------------------------------------------------------------------------

/* Menu principal */
int menu_principal(void)
{
  int escolha;

  do {
    printf("\n***************Menu Principal************************* \n");
    printf("         1. Geracao de uma Solacao Inicial Aleatoria \n");
    printf("         2. Simulated Annealing \n");
    printf("         0. Sair \n");
    printf("         Escolha: ");
    scanf("%d",&escolha);
  } while (escolha < 0 || escolha > 2);
  return escolha;
}






